'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Authorization = function (_Resource) {
    (0, _inherits3.default)(Authorization, _Resource);

    function Authorization() {
        (0, _classCallCheck3.default)(this, Authorization);
        return (0, _possibleConstructorReturn3.default)(this, (Authorization.__proto__ || (0, _getPrototypeOf2.default)(Authorization)).apply(this, arguments));
    }

    (0, _createClass3.default)(Authorization, [{
        key: 'get',


        /**
         * @api {get} /v1/auth get
         * @apiGroup Authorization
         * @apiName get
         * @apiDescription Generate or regenerate authorization information for the current user.
         * @apiExample {js} Example:
         *             gigwalk.authorization.get({ ... })
         */
        value: function get() {
            return this.client.get('/v1/auth');
        }

        /**
         * @api {post} /v1/auth create
         * @apiGroup Authorization
         * @apiName create
         * @apiDescription Generate or regenerate authorization information for the current user.
         * @apiExample {js} Example:
         *             gigwalk.authorization.create({ ... })
         */

    }, {
        key: 'create',
        value: function create() {
            return this.client.post('/v1/auth');
        }

        /**
         * @api {post} /v1/forgot_password forgotPassword
         * @apiGroup Authorization
         * @apiName forgotPassword
         * @apiDescription Sends an email to the customer to reset their password. Authorization is not required.
         * @apiParam {String} email
         * @apiExample {js} Example:
         *             gigwalk.authorization.forgotPassword({ ... })
         */

    }, {
        key: 'forgotPassword',
        value: function forgotPassword(params) {
            return this.client.post('/v1/forgot_password', (0, _extends3.default)({}, params));
        }

        /**
         * @api {post} /v1/reset_password resetPassword
         * @apiGroup Authorization
         * @apiName resetPassword
         * @apiDescription Reset the customer's password. Returns the customer's information.
         * @apiParam {String} email
         * @apiParam {String} password
         * @apiParam {String} token
         * @apiParam {Boolean} [check_expired]
         * @apiExample {js} Example:
         *             gigwalk.authorization.resetPassword({ ... })
         */

    }, {
        key: 'resetPassword',
        value: function resetPassword(params) {
            return this.client.post('/v1/reset_password', (0, _extends3.default)({}, params));
        }
    }]);
    return Authorization;
}(_resource2.default);

exports.default = Authorization;
//# sourceMappingURL=index.js.map