'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CalendarEvents = function (_Resource) {
    (0, _inherits3.default)(CalendarEvents, _Resource);

    function CalendarEvents() {
        (0, _classCallCheck3.default)(this, CalendarEvents);
        return (0, _possibleConstructorReturn3.default)(this, (CalendarEvents.__proto__ || (0, _getPrototypeOf2.default)(CalendarEvents)).apply(this, arguments));
    }

    (0, _createClass3.default)(CalendarEvents, [{
        key: 'delete',


        /**
         * @api {delete} /v1/calendar_events/:calendar_event_id delete
         * @apiGroup CalendarEvents
         * @apiName delete
         * @apiDescription Delete a calendarEvent.
         * @apiParam {Number} calendar_event_id
         * @apiExample {js} Example:
         *             gigwalk.calendarEvents.delete({...})
         */
        value: function _delete(params) {
            return this.client.delete('/v1/calendar_events/' + params.calendar_event_id);
        }

        /**
         * @api {get} /v1/calendar_events/:calendar_event_id get
         * @apiGroup CalendarEvents
         * @apiName get
         * @apiDescription Get calendarEvent.
         * @apiParam {Number} calendar_event_id
         * @apiParam {String} [time_zone='UTC']
         * @apiExample {js} Example:
         *             gigwalk.calendarEvents.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var data = {
                time_zone: params.time_zone ? params.time_zone : 'UTC'
            };

            return this.client.get('/v1/calendar_events/' + params.calendar_event_id, data);
        }

        /**
         * @api {put} /v1/calendar_events/:calendar_event_id update
         * @apiGroup CalendarEvents
         * @apiName update
         * @apiDescription Modify calendarEvent information.
         * @apiParam {Number} calendar_event_id
         * @apiParam {Object} calendar_event
         * @apiExample {js} Example:
         *             gigwalk.calendarEvents.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            return this.client.put('/v1/calendar_events/' + params.calendar_event_id, (0, _extends3.default)({}, params.calendar_event));
        }

        /**
         * @api {post} /v1/calendar_events create
         * @apiGroup CalendarEvents
         * @apiName create
         * @apiDescription Create a calendarEvent.
         * @apiParam {Object} calendar_event
         * @apiExample {js} Example:
         *             gigwalk.calendarEvents.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            return this.client.post('/v1/calendar_events', (0, _extends3.default)({}, params.calendar_event));
        }

        /**
         * @api {get} /v1/customers/:customer_id/calendar_events getForCustomer
         * @apiGroup CalendarEvents
         * @apiName getForCustomer
         * @apiDescription Get all calendarEvents belonging to the customer.
         * @apiParam {Number} customer_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.calendarEvents.getForCustomer({...})
         */

    }, {
        key: 'getForCustomer',
        value: function getForCustomer(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/customers/' + params.customer_id + '/calendar_events' + query);
        }
    }]);
    return CalendarEvents;
}(_resource2.default);

exports.default = CalendarEvents;
//# sourceMappingURL=index.js.map