'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CustomerListFileUpload = function (_Resource) {
    (0, _inherits3.default)(CustomerListFileUpload, _Resource);

    function CustomerListFileUpload() {
        (0, _classCallCheck3.default)(this, CustomerListFileUpload);
        return (0, _possibleConstructorReturn3.default)(this, (CustomerListFileUpload.__proto__ || (0, _getPrototypeOf2.default)(CustomerListFileUpload)).apply(this, arguments));
    }

    (0, _createClass3.default)(CustomerListFileUpload, [{
        key: 'upload',


        /**
         * @api {post} /v1/organizations/{organization_id}/customer/upload upload
         * @apiGroup CustomerListFileUpload
         * @apiName upload
         * @apiDescription Upload a customerList file.
         * @apiParam {Number} organization_id
         * @apiParam {Object} customer_list_file
         * @apiExample {js} Example:
         *             gigwalk.customerListFileUpload.upload({...})
         */
        value: function upload(params) {
            var data = {
                customer_list_file_name: params.customer_list_file.name,
                key: params.customer_list_file.key
            };

            return this.client.post('/v1/organizations/' + params.organization_id + '/customer/upload', data);
        }

        /**
         * @api {get} /v1/organizations/{organization_id}/customer/{customer_file_id}/upload getForOrganization
         * @apiGroup CustomerListFileUpload
         * @apiName getForOrganization
         * @apiDescription Get file information about the specified customerFileUpload.
         * @apiParam {Number} organization_id
         * @apiParam {Number} customer_file_id
         * @apiExample {js} Example:
         *             gigwalk.customerListFileUpload.getForOrganization({...})
         */

    }, {
        key: 'getForOrganization',
        value: function getForOrganization(params) {
            return this.client.get('/v1/organizations/' + params.organization_id + '/customer/' + params.customer_file_id + '/upload');
        }

        /**
         * @api {get} /v1/customer/{customer_file_id}/upload get
         * @apiGroup CustomerListFileUpload
         * @apiName get
         * @apiDescription Get file information about the specified customerFileUpload.
         * @apiParam {Number} customer_file_id
         * @apiExample {js} Example:
         *             gigwalk.customerListFileUpload.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            return this.client.get('/v1/customer/' + params.customer_file_id + '/upload');
        }
    }]);
    return CustomerListFileUpload;
}(_resource2.default);

exports.default = CustomerListFileUpload;
//# sourceMappingURL=index.js.map