'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CustomerStatistics = function (_Resource) {
    (0, _inherits3.default)(CustomerStatistics, _Resource);

    function CustomerStatistics() {
        (0, _classCallCheck3.default)(this, CustomerStatistics);
        return (0, _possibleConstructorReturn3.default)(this, (CustomerStatistics.__proto__ || (0, _getPrototypeOf2.default)(CustomerStatistics)).apply(this, arguments));
    }

    (0, _createClass3.default)(CustomerStatistics, [{
        key: 'getByID',


        /**
         * @api {get} /v1/admin/customerstats/:customer_id getByID
         * @apiGroup CustomerStatistics
         * @apiName getByID
         * @apiDescription Get information about the work history of a customer and prospective tickets. Platform admin access only.
                           Returns rendered HTML using jinja templates.
         * @apiParam {Number} customer_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customerStatistics.getByID({...})
         */
        value: function getByID(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/admin/customerstats/' + params.customer_id + query);
        }

        /**
         * @api {get} /v1/admin/customerstats/:email getByEmail
         * @apiGroup CustomerStatistics
         * @apiName getByEmail
         * @apiDescription Get information about the work history of a customer and prospective tickets. Platform admin access only.
                           Returns rendered HTML using jinja templates.
         * @apiParam {String} email
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customerStatistics.getByEmail({...})
         */

    }, {
        key: 'getByEmail',
        value: function getByEmail(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/admin/customerstats/' + params.email + query);
        }

        /**
         * @api {get} /v1/admin/customers_tickets/ get
         * @apiGroup CustomerStatistics
         * @apiName get
         * @apiDescription Get information about the work history of a customer and prospective tickets. Platform admin access only.
                           Returns rendered HTML using jinja templates.
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customerStatistics.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var query = params ? this.stringForQueryObject(params.query) : '';

            return this.client.get('/v1/admin/customers_tickets/' + query);
        }

        /**
         * @api {get} /v1/tickets/:ticket_id/customers/location_search getByTicket
         * @apiGroup CustomerStatistics
         * @apiName getByTicket
         * @apiDescription Get information about tickets' owners.
         * @apiParam {Number} ticket_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customerStatistics.getByTicket({...})
         */

    }, {
        key: 'getByTicket',
        value: function getByTicket(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/tickets/' + params.ticket_id + '/customers/location_search' + query);
        }
    }]);
    return CustomerStatistics;
}(_resource2.default);

exports.default = CustomerStatistics;
//# sourceMappingURL=index.js.map