'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Customers = function (_Resource) {
    (0, _inherits3.default)(Customers, _Resource);

    function Customers() {
        (0, _classCallCheck3.default)(this, Customers);
        return (0, _possibleConstructorReturn3.default)(this, (Customers.__proto__ || (0, _getPrototypeOf2.default)(Customers)).apply(this, arguments));
    }

    (0, _createClass3.default)(Customers, [{
        key: 'deleteByEmail',

        /**
         * @api {delete} /v1/organizations/:organization_id/customers/:customer_email deleteByEmail
         * @apiGroup Customers
         * @apiName deleteByEmail
         * @apiDescription The customers status is set to DELETED. The customers metadata is hard deleted.
         * @apiParam {Number} organization_id
         * @apiParam {String} customer_email
         * @apiExample {js} Example:
         *             gigwalk.customers.deleteByEmail({...})
         */
        value: function deleteByEmail(params) {
            return this.client.delete('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_email);
        }

        /**
         * @api {get} /v1/organizations/:organization_id/customers/:customer_email getByEmail
         * @apiGroup Customers
         * @apiName getByEmail
         * @apiDescription If the customer exists, return information about the specified customer.
         * @apiParam {Number} organization_id
         * @apiParam {String} customer_email
         * @apiParam {Number[]} require_cert_ids
         * @apiParam {Number[]} exclude_cert_ids
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customers.getByEmail({...})
         */

    }, {
        key: 'getByEmail',
        value: function getByEmail(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                require_cert_ids: params.require_cert_ids ? params.require_cert_ids : [],
                exclude_cert_ids: params.exclude_cert_ids ? params.exclude_cert_ids : []
            };

            return this.client.get('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_email + query, data);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/customers/:customer_email updateByEmail
         * @apiGroup Customers
         * @apiName updateByEmail
         * @apiDescription Modifies customer information identified by customer_email.
         * @apiParam {Number} organization_id
         * @apiParam {String} customer_email
         * @apiParam {Object} customer
         * @apiExample {js} Example:
         *             gigwalk.customers.updateByEmail({...})
         */

    }, {
        key: 'updateByEmail',
        value: function updateByEmail(params) {
            return this.client.put('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_email, (0, _extends3.default)({}, params.customer));
        }

        /**
         * @api {delete} /v1/organizations/:organization_id/customers/:customer_id deleteById
         * @apiGroup Customers
         * @apiName deleteById
         * @apiDescription The customers status is set to DELETED. The customers metadata is hard deleted.
         * @apiParam {Number} organization_id
         * @apiParam {Number} customer_id
         * @apiExample {js} Example:
         *             gigwalk.customers.deleteById({...})
         */

    }, {
        key: 'deleteById',
        value: function deleteById(params) {
            return this.client.delete('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_id);
        }

        /**
         * @api {get} /v1/organizations/:organization_id/customers/:customer_id getById
         * @apiGroup Customers
         * @apiName getById
         * @apiDescription If the customer exists, return information about the specified customer.
         * @apiParam {Number} organization_id
         * @apiParam {Number} customer_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customers.getById({...})
         */

    }, {
        key: 'getById',
        value: function getById(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_id + query);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/customers/:customer_id updateById
         * @apiGroup Customers
         * @apiName updateById
         * @apiDescription Modifies customer information identified by customer_id.
         * @apiParam {Number} organization_id
         * @apiParam {Number} customer_id
         * @apiParam {Object} customer
         * @apiExample {js} Example:
         *             gigwalk.customers.updateById({...})
         */

    }, {
        key: 'updateById',
        value: function updateById(params) {
            return this.client.put('/v1/organizations/' + params.organization_id + '/customers/' + params.customer_id, (0, _extends3.default)({}, params.customer));
        }

        /**
         * @api {get} /v1/organizations/:organization_id/customers getAllForOrganization
         * @apiGroup Customers
         * @apiName getAllForOrganization
         * @apiDescription Return information about all customers of an organization. Capable of returning paginated results.
         * @apiParam {Number} organization_id
         * @apiParam {Number[]} require_cert_ids
         * @apiParam {Number[]} exclude_cert_ids
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customers.getAllForOrganization({...})
         */

    }, {
        key: 'getAllForOrganization',
        value: function getAllForOrganization(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                require_cert_ids: params.require_cert_ids ? params.require_cert_ids : [],
                exclude_cert_ids: params.exclude_cert_ids ? params.exclude_cert_ids : []
            };

            return this.client.get('/v1/organizations/' + params.organization_id + '/customers' + query, data);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/customers updateForOrganization
         * @apiGroup Customers
         * @apiName updateForOrganization
         * @apiDescription Modify information of customer(s) identified by customer_email. Soft delete multiple customers by setting DELETED status.
         * @apiParam {Number} organization_id
         * @apiParam {Object[]} customers
         * @apiExample {js} Example:
         *             gigwalk.customers.updateForOrganization({...})
         */

    }, {
        key: 'updateForOrganization',
        value: function updateForOrganization(params) {
            var data = {
                action: 'UPDATE',
                customers: params.customers
            };

            return this.client.put('/v1/organizations/' + params.organization_id + '/customers', data);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/customers bulkDeleteForOrganization
         * @apiGroup Customers
         * @apiName bulkDeleteForOrganization
         * @apiDescription Delete customer(s).
         * @apiParam {Number} organization_id
         * @apiParam {Object[]} customers
         * @apiExample {js} Example:
         *             gigwalk.customers.bulkDeleteForOrganization({...})
         */

    }, {
        key: 'bulkDeleteForOrganization',
        value: function bulkDeleteForOrganization(params) {
            var data = {
                action: 'REMOVE',
                customers: params.customers
            };

            return this.client.put('/v1/organizations/' + params.organization_id + '/customers', data);
        }

        /**
         * @api {get} /v1/customer get
         * @apiGroup Customers
         * @apiName get
         * @apiDescription Return current customer's information.
         * @apiExample {js} Example:
         *             gigwalk.customers.get({...})
         */

    }, {
        key: 'get',
        value: function get() {
            return this.client.get('/v1/customer');
        }

        /**
         * @api {put} /v1/customer update
         * @apiGroup Customers
         * @apiName update
         * @apiDescription Modify current users information.
         * @apiParam {Object} customer
         * @apiExample {js} Example:
         *             gigwalk.customers.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            return this.client.put('/v1/customer', (0, _extends3.default)({}, params.customer));
        }

        /**
         * @api {post} /v1/tickets/search/customers search
         * @apiGroup Customers
         * @apiName search
         * @apiDescription Return all the customers related with the given group(s) or with the groups related with the ticket(s). Also checks if the customers
                           have availability to execute given tickets. Capable of returning paginated results.
         * @apiParam {Number[]} ticket_ids
         * @apiParam {Number[]} [group_ids]
         * @apiParam {Number[]} [required_certifications]
         * @apiParam {String} [q]
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customers.search({...})
         */

    }, {
        key: 'search',
        value: function search(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                ticket_ids: params.ticket_ids,
                group_ids: params.group_ids ? params.group_ids : [],
                required_certifications: params.required_certifications ? params.required_certifications : [],
                q: params.q ? params.q : ''
            };

            return this.client.post('/v1/tickets/search/customers' + query, data);
        }
    }]);
    return Customers;
}(_resource2.default);

exports.default = Customers;
//# sourceMappingURL=index.js.map