'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataItems = function (_Resource) {
    (0, _inherits3.default)(DataItems, _Resource);

    function DataItems() {
        (0, _classCallCheck3.default)(this, DataItems);
        return (0, _possibleConstructorReturn3.default)(this, (DataItems.__proto__ || (0, _getPrototypeOf2.default)(DataItems)).apply(this, arguments));
    }

    (0, _createClass3.default)(DataItems, [{
        key: 'get',


        /**
         * @api {get} /v1/data_items/search get
         * @apiGroup DataItems
         * @apiName get
         * @apiDescription Get the results of a mongo aggregate query.
         * @apiParam {String} aggregate
         * @apiExample {js} Example:
         *             gigwalk.dataItems.get({...})
         */
        value: function get(params) {
            var data = {
                aggregate: params.aggregate
            };

            return this.client.get('/v1/data_items/search', data);
        }

        /**
         * @api {post} /v1/data_items/search search
         * @apiGroup DataItems
         * @apiName search
         * @apiDescription Search for dataItems. No permissions check.
         * @apiParam {Object} query
         * @apiExample {js} Example:
         *             gigwalk.dataItems.search({...})
         */

    }, {
        key: 'search',
        value: function search(params) {
            return this.client.post('/v1/data_items/search', (0, _extends3.default)({}, params.query));
        }

        /**
         * @api {post} /v1/organizations/:organization_id/data_items/search searchForOrganization
         * @apiGroup DataItems
         * @apiName searchForOrganization
         * @apiDescription Search for dataItems. No permissions check.
         * @apiParam {Number} organization_id
         * @apiParam {Object} query
         * @apiExample {js} Example:
         *             gigwalk.dataItems.searchForOrganization({...})
         */

    }, {
        key: 'searchForOrganization',
        value: function searchForOrganization(params) {
            return this.client.post('/v1/organizations/' + params.organization_id + '/data_items/search', (0, _extends3.default)({}, params.query));
        }

        /**
         * @api {post} /v1/subscriptions/:subscription_id/data_items/search searchForSubscription
         * @apiGroup DataItems
         * @apiName searchForSubscription
         * @apiDescription Search for dataItems. No permissions check.
         * @apiParam {Number} subscription_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.dataItems.searchForSubscription({...})
         */

    }, {
        key: 'searchForSubscription',
        value: function searchForSubscription(params) {
            return this.client.post('/v1/subscriptions/' + params.subscription_id + '/data_items/search', (0, _extends3.default)({}, params.query));
        }
    }]);
    return DataItems;
}(_resource2.default);

exports.default = DataItems;
//# sourceMappingURL=index.js.map