'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataTypeAttachment = function (_Resource) {
    (0, _inherits3.default)(DataTypeAttachment, _Resource);

    function DataTypeAttachment() {
        (0, _classCallCheck3.default)(this, DataTypeAttachment);
        return (0, _possibleConstructorReturn3.default)(this, (DataTypeAttachment.__proto__ || (0, _getPrototypeOf2.default)(DataTypeAttachment)).apply(this, arguments));
    }

    (0, _createClass3.default)(DataTypeAttachment, [{
        key: 'delete',


        /**
         * @api {delete} /v1/data_types/:data_type_id/attachments delete
         * @apiGroup DataTypeAttachment
         * @apiName delete
         * @apiDescription Delete the attachment defined in the body of a dataType
         * @apiParam {Number} data_type_id
         * @apiParam {String} url
         * @apiExample {js} Example:
         *             gigwalk.dataTypeAttachment.delete({...})
         */
        value: function _delete(params) {
            var data = {
                url: params.url
            };
            return this.client.delete('/v1/data_types/' + params.data_type_id + '/attachments', data);
        }

        /**
         * @api {post} /v1/data_types/:data_type_id/attachments create
         * @apiGroup DataTypeAttachment
         * @apiName create
         * @apiDescription Create a new dataTypeAttachment. Modifies the information of the specified dataType.
         * @apiParam {Number} data_type_id
         * @apiParam {Object} attachment
         * @apiExample {js} Example:
         *             gigwalk.dataTypeAttachment.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            return this.client.post('/v1/data_types/' + params.data_type_id + '/attachments', (0, _extends3.default)({}, params.attachment));
        }
    }]);
    return DataTypeAttachment;
}(_resource2.default);

exports.default = DataTypeAttachment;
//# sourceMappingURL=index.js.map