'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataTypes = function (_Resource) {
    (0, _inherits3.default)(DataTypes, _Resource);

    function DataTypes() {
        (0, _classCallCheck3.default)(this, DataTypes);
        return (0, _possibleConstructorReturn3.default)(this, (DataTypes.__proto__ || (0, _getPrototypeOf2.default)(DataTypes)).apply(this, arguments));
    }

    (0, _createClass3.default)(DataTypes, [{
        key: 'searchWithField',


        /**
         * @api {post} /v2/organizations/:organization_id/search/data_types/filters searchWithField
         * @apiGroup DataTypes
         * @apiName searchWithField
         * @apiDescription Search all dataTypes for the given value being present in the given searchField.
         * @apiParam {Number} organization_id
         * @apiParam {String} search_field
         * @apiParam {String} query_string
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.searchWithField({...})
         */
        value: function searchWithField(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                search_field: params.search_field,
                query_string: params.query_string
            };

            return this.client.post('/v2/organizations/' + params.organization_id + '/search/data_types/filters' + query, data);
        }

        /**
         * @api {post} /v2/organizations/:organization_id/search/data_types search
         * @apiGroup DataTypes
         * @apiName search
         * @apiDescription Search all dataTypes for the given string.
         * @apiParam {Number} organization_id
         * @apiParam {String} query_string
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.search({...})
         */

    }, {
        key: 'search',
        value: function search(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                query_string: params.query_string
            };

            return this.client.post('/v2/organizations/' + params.organization_id + '/search/data_types' + query, data);
        }

        /**
         * @api {get} /v1/data_types getAll
         * @apiGroup DataTypes
         * @apiName getAll
         * @apiDescription Get dataType. Lists all dataTypes of an organization.
         * @apiParam {Number} [observation_target_type_id=0]
         * @apiParam {Number} [dashboard_visible=1]
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.getAll({...})
         */

    }, {
        key: 'getAll',
        value: function getAll(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                observation_target_type_id: params.observation_target_type_id ? params.observation_target_type_id : 0,
                dashboard_visible: params.dashboard_visible ? params.dashboard_visible : 1
            };

            return this.client.get('/v1/data_types' + query, data);
        }

        /**
         * @api {post} /v1/data_types create
         * @apiGroup DataTypes
         * @apiName create
         * @apiDescription Create a new dataType using the given info.
         * @apiParam {Object} dataType
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            return this.client.post('/v1/data_types', (0, _extends3.default)({}, params.dataType));
        }

        /**
         * @api {get} /v1/data_types/:data_type_id get
         * @apiGroup DataTypes
         * @apiName get
         * @apiDescription Get dataType. Returns information about the specified dataType.
         * @apiParam {Number} data_type_id
         * @apiParam {Number} [observation_target_type_id=0]
         * @apiParam {Number} [dashboard_visible=1]
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                observation_target_type_id: params.observation_target_type_id ? params.observation_target_type_id : 0,
                dashboard_visible: params.dashboard_visible ? params.dashboard_visible : 1
            };

            return this.client.get('/v1/data_types/' + params.data_type_id + query, data);
        }

        /**
         * @api {put} /v1/data_types/:data_type_id update
         * @apiGroup DataTypes
         * @apiName update
         * @apiDescription Modify dataType.
         * @apiParam {Number} data_type_id
         * @apiParam {Object} dataType
         * @apiExample {js} Example:
         *             gigwalk.dataTypes.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            return this.client.put('/v1/data_types/' + params.data_type_id, (0, _extends3.default)({}, params.dataType));
        }
    }]);
    return DataTypes;
}(_resource2.default);

exports.default = DataTypes;
//# sourceMappingURL=index.js.map