'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GroupSearch = function (_Resource) {
    (0, _inherits3.default)(GroupSearch, _Resource);

    function GroupSearch() {
        (0, _classCallCheck3.default)(this, GroupSearch);
        return (0, _possibleConstructorReturn3.default)(this, (GroupSearch.__proto__ || (0, _getPrototypeOf2.default)(GroupSearch)).apply(this, arguments));
    }

    (0, _createClass3.default)(GroupSearch, [{
        key: 'searchWithType',


        /**
         * @api {get} /v1/groups/:group_id/search/:index_type searchWithType
         * @apiGroup GroupSearch
         * @apiName searchWithType
         * @apiDescription Search for the given queryString in either groups tickets or members.
         * @apiParam {Number} group_id
         * @apiParam {String} [index_type='tickets']
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.groupSearch.searchWithType({...})
         */
        value: function searchWithType(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/groups/' + params.group_id + '/search/' + (params.index_type ? params.index_type : 'tickets') + query);
        }

        /**
         * @api {post} /v2/groups/:group_id/search/tickets search
         * @apiGroup GroupSearch
         * @apiName search
         * @apiDescription Search for the given queryString in tickets within the group. This will search in all strings in the group doc.
         * @apiParam {Number} group_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.groupSearch.search({...})
         */

    }, {
        key: 'search',
        value: function search(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.post('/v2/groups/' + params.group_id + '/search/tickets' + query);
        }

        /**
         * @api {post} /v2/groups/:group_id/search/tickets/filters searchTickets
         * @apiGroup GroupSearch
         * @apiName searchTickets
         * @apiDescription Filter tickets of the group (e.g. TICKET_STATUS = SUBMITTED).
         * @apiParam {Number} group_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.groupSearch.searchTickets({...})
         */

    }, {
        key: 'searchTickets',
        value: function searchTickets(params) {
            return this.client.post('/v2/groups/' + params.group_id + '/search/tickets/filters', (0, _extends3.default)({}, params.query));
        }
    }]);
    return GroupSearch;
}(_resource2.default);

exports.default = GroupSearch;
//# sourceMappingURL=index.js.map