'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OrganizationMetadata = function (_Resource) {
    (0, _inherits3.default)(OrganizationMetadata, _Resource);

    function OrganizationMetadata() {
        (0, _classCallCheck3.default)(this, OrganizationMetadata);
        return (0, _possibleConstructorReturn3.default)(this, (OrganizationMetadata.__proto__ || (0, _getPrototypeOf2.default)(OrganizationMetadata)).apply(this, arguments));
    }

    (0, _createClass3.default)(OrganizationMetadata, [{
        key: 'get',


        /**
         * @api {get} /v1/organizations/:organization_id/subscription_metadata_fields get
         * @apiGroup OrganizationMetadata
         * @apiName get
         * @apiDescription Get all metadata for an organization.
         * @apiParam {Number} organization_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.organizationMetadata.get({...})
         */
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/subscription_metadata_fields' + query);
        }

        /**
         * @api {post} /v1/organizations/:organization_id/subscription_metadata_fields create
         * @apiGroup OrganizationMetadata
         * @apiName create
         * @apiDescription Create organization metadata.
         * @apiParam {Number} organization_id
         * @apiParam {String} name
         * @apiExample {js} Example:
         *             gigwalk.organizationMetadata.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            var data = {
                name: params.name
            };

            return this.client.post('/v1/organizations/' + params.organization_id + '/subscription_metadata_fields', data);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/subscription_metadata_fields/:organization_metadata_field_id update
         * @apiGroup OrganizationMetadata
         * @apiName update
         * @apiDescription Update organization metadata field.
         * @apiParam {Number} organization_id
         * @apiParam {Number} organization_metadata_field_id
         * @apiParam {String} name
         * @apiParam {Object} metadata
         * @apiExample {js} Example:
         *             gigwalk.organizationMetadata.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            var query = this.stringForQueryObject(params.query);
            var data = {
                name: params.name
            };

            return this.client.put('/v1/organizations/' + params.organization_id + '/subscription_metadata_fields/' + params.organization_metadata_field_id + query, data);
        }

        /**
         * @api {get} /v1/organizations/:organization_id/subscription_metadata_fields/:organization_metadata_field_id/values getField
         * @apiGroup OrganizationMetadata
         * @apiName getField
         * @apiDescription Get organization metadata field.
         * @apiParam {Number} organization_id
         * @apiParam {Number} organization_metadata_field_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.organizationMetadata.getField({...})
         */

    }, {
        key: 'getField',
        value: function getField(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/subscription_metadata_fields/' + params.organization_metadata_field_id + '/values' + query);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/subscription_metadata_fields/:organization_metadata_field_id/values updateField
         * @apiGroup OrganizationMetadata
         * @apiName updateField
         * @apiDescription Update organization metadata.
         * @apiParam {Number} organization_id
         * @apiParam {Number} organization_metadata_field_id
         * @apiParam {Object} metadata
         * @apiExample {js} Example:
         *             gigwalk.organizationMetadata.updateField({...})
         */

    }, {
        key: 'updateField',
        value: function updateField(params) {
            return this.client.put('/v1/organizations/' + params.organization_id + '/subscription_metadata_fields/' + params.organization_metadata_field_id + '/values', (0, _extends3.default)({}, params.metadata));
        }
    }]);
    return OrganizationMetadata;
}(_resource2.default);

exports.default = OrganizationMetadata;
//# sourceMappingURL=index.js.map