'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Search = function (_Resource) {
    (0, _inherits3.default)(Search, _Resource);

    function Search() {
        (0, _classCallCheck3.default)(this, Search);
        return (0, _possibleConstructorReturn3.default)(this, (Search.__proto__ || (0, _getPrototypeOf2.default)(Search)).apply(this, arguments));
    }

    (0, _createClass3.default)(Search, [{
        key: 'searchDocuments',

        /**
         * @api {get} /v1/search searchDocuments
         * @apiGroup Search
         * @apiName searchDocuments
         * @apiDescription Search all ES docs for the given queryString. Returns results in ES idiom.
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.customers.searchDocuments({...})
         */
        value: function searchDocuments(params) {
            var query = params ? this.stringForQueryObject(params.query) : '';

            return this.client.get('/v1/search' + query);
        }

        /**
         * @api {post} /v1/search create
         * @apiGroup Search
         * @apiName create
         * @apiDescription Not implemented.
         * @apiExample {js} Example:
         *             gigwalk.search.create({...})
         */

    }, {
        key: 'create',
        value: function create() {
            return this.client.post('/v1/search');
        }

        /**
         * @api {get} /v1/organizations/:organization_id/search/:index_type searchOrganization
         * @apiGroup Search
         * @apiName searchOrganization
         * @apiDescription Search in an organization. Capable of returning paginated results.
         * @apiParam {Number} organization_id
         * @apiParam {String} [index_type='tickets']
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.search.searchOrganization({...})
         */

    }, {
        key: 'searchOrganization',
        value: function searchOrganization(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/search/' + (params.index_type ? params.index_type : 'tickets') + query);
        }
    }]);
    return Search;
}(_resource2.default);

exports.default = Search;
//# sourceMappingURL=index.js.map