'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Targets = function (_Resource) {
    (0, _inherits3.default)(Targets, _Resource);

    function Targets() {
        (0, _classCallCheck3.default)(this, Targets);
        return (0, _possibleConstructorReturn3.default)(this, (Targets.__proto__ || (0, _getPrototypeOf2.default)(Targets)).apply(this, arguments));
    }

    (0, _createClass3.default)(Targets, [{
        key: 'create',

        /**
         * @api {post} /v1/organizations/:organization_id/observation_targets create
         * @apiGroup Targets
         * @apiName create
         * @apiDescription Create new obs_target(s). Endpoint also does update/deletion.
         * @apiParam {Number} organization_id
         * @apiParam {Object} observation_target
         * @apiExample {js} Example:
         *             gigwalk.targets.create({...})
         */
        value: function create(params) {
            return this.client.post('/v1/organizations/' + params.organization_id + '/observation_targets', (0, _extends3.default)({}, params.observation_target));
        }

        /**
         * @api {get} /v1/organizations/:organization_id/observation_targets/:observation_target_id get
         * @apiGroup Targets
         * @apiName get
         * @apiDescription If target_id is specified, return organizationObservationTargetID information; else return the information for all targets of
                           the organization. Capable of returning paginated results.
         * @apiParam {Number} organization_id
         * @apiParam {Number} observation_target_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.targets.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/observation_targets/' + params.observation_target_id + query);
        }

        /**
         * @api {put} /v1/organizations/:organization_id/observation_targets/:observation_target_id update
         * @apiGroup Targets
         * @apiName update
         * @apiDescription If targetID is specified, update organizationObservationTarget; else update all targets of the organization.
                           Endpoint also does update/deletion.
         * @apiParam {Number} organization_id
         * @apiParam {Number} observation_target_id
         * @apiParam {Object} observation_target
         * @apiExample {js} Example:
         *             gigwalk.targets.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            return this.client.put('/v1/organizations/' + params.organization_id + '/observation_targets/' + params.observation_target_id, (0, _extends3.default)({}, params.observation_target));
        }

        /**
         * @api {get} /v1/organizations/:organization_id/observation_targets/search search
         * @apiGroup Targets
         * @apiName search
         * @apiDescription Search obs_target titles. Capable of returning paginated results.
         * @apiParam {Number} organization_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.targets.search({...})
         */

    }, {
        key: 'search',
        value: function search(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organizations/' + params.organization_id + '/observation_targets/search' + query);
        }
    }]);
    return Targets;
}(_resource2.default);

exports.default = Targets;
//# sourceMappingURL=index.js.map