'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Templates = function (_Resource) {
    (0, _inherits3.default)(Templates, _Resource);

    function Templates() {
        (0, _classCallCheck3.default)(this, Templates);
        return (0, _possibleConstructorReturn3.default)(this, (Templates.__proto__ || (0, _getPrototypeOf2.default)(Templates)).apply(this, arguments));
    }

    (0, _createClass3.default)(Templates, [{
        key: 'getAll',


        /**
         * @api {get} /v1/templates getAll
         * @apiGroup Templates
         * @apiName getAll
         * @apiDescription Get all templates. If platform admin, view all active templates. Otherwise, view an organizations active templates.
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.templates.getAll({...})
         */
        value: function getAll(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/templates' + query);
        }

        /**
         * @api {post} /v1/templates bulkCreate
         * @apiGroup Templates
         * @apiName bulkCreate
         * @apiDescription Create new template(s).
         * @apiParam {Object} template
         * @apiExample {js} Example:
         *             gigwalk.templates.bulkCreate({...})
         */

    }, {
        key: 'bulkCreate',
        value: function bulkCreate(params) {
            var data = {
                templates: params.templates
            };

            return this.client.post('/v1/templates', data);
        }

        /**
         * @api {delete} /v1/templates/:template_id delete
         * @apiGroup Templates
         * @apiName delete
         * @apiDescription Delete template. Template is made INACTIVE, acts as soft delete.
         * @apiParam {Number} template_id
         * @apiExample {js} Example:
         *             gigwalk.templates.delete({...})
         */

    }, {
        key: 'delete',
        value: function _delete(params) {
            return this.client.delete('/v1/templates/' + params.template_id);
        }

        /**
         * @api {get} /v1/templates/:template_id get
         * @apiGroup Templates
         * @apiName get
         * @apiDescription Get information about the specified template.
         * @apiParam {Number} template_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.templates.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/templates/' + params.template_id + query);
        }

        /**
         * @api {put} /v1/templates/:template_id update
         * @apiGroup Templates
         * @apiName update
         * @apiDescription Update template.
         * @apiParam {Number} template_id
         * @apiParam {Object} template
         * @apiExample {js} Example:
         *             gigwalk.templates.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            return this.client.put('/v1/templates/' + params.template_id, (0, _extends3.default)({}, params.template));
        }
    }]);
    return Templates;
}(_resource2.default);

exports.default = Templates;
//# sourceMappingURL=index.js.map