'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TicketMetadata = function (_Resource) {
    (0, _inherits3.default)(TicketMetadata, _Resource);

    function TicketMetadata() {
        (0, _classCallCheck3.default)(this, TicketMetadata);
        return (0, _possibleConstructorReturn3.default)(this, (TicketMetadata.__proto__ || (0, _getPrototypeOf2.default)(TicketMetadata)).apply(this, arguments));
    }

    (0, _createClass3.default)(TicketMetadata, [{
        key: 'get',


        /**
         * @api {get} /v1/tickets/:ticket_id/metadata get
         * @apiGroup TicketMetadata
         * @apiName get
         * @apiDescription Given a ticket_id, fetch its metadata.
         * @apiParam {Number} ticket_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.ticketMetadata.get({...})
         */
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/tickets/' + params.ticket_id + '/metadata' + query);
        }

        /**
         * @api {post} /v1/tickets/:ticket_id/metadata create
         * @apiGroup TicketMetadata
         * @apiName create
         * @apiDescription Create metadata for the given ticket. Use an array of key-value pairs to add ticket metadata.
         * @apiParam {Number} ticket_id
         * @apiParam {Object} metadata
         * @apiExample {js} Example:
         *             gigwalk.ticketMetadata.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            return this.client.post('/v1/tickets/' + params.ticket_id + '/metadata', (0, _extends3.default)({}, params.metadata));
        }

        /**
         * @api {put} /v1/tickets/:ticket_id/metadata update
         * @apiGroup TicketMetadata
         * @apiName update
         * @apiDescription Update metadata for the given ticket. Use an array of key-value pairs to update ticket metadata.
         * @apiParam {Number} ticket_id
         * @apiParam {Object} metadata
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.ticketMetadata.update({...})
         */

    }, {
        key: 'update',
        value: function update(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.put('/v1/tickets/' + params.ticket_id + '/metadata' + query, (0, _extends3.default)({}, params.metadata));
        }

        /**
         * @api {put} /v1/organizations/:organization_id/tickets/:ticket_id updateForOrganization
         * @apiGroup TicketMetadata
         * @apiName updateForOrganization
         * @apiDescription Update metadata for the given ticket. Use an array of key-value pairs to update ticket metadata.
         * @apiParam {Number} organization_id
         * @apiParam {Number} ticket_id
         * @apiParam {Object} metadata
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.ticketMetadata.updateForOrganization({...})
         */

    }, {
        key: 'updateForOrganization',
        value: function updateForOrganization(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.put('/v1/organizations/' + params.organization_id + '/tickets/' + params.ticket_id + query, (0, _extends3.default)({}, params.metadata));
        }
    }]);
    return TicketMetadata;
}(_resource2.default);

exports.default = TicketMetadata;
//# sourceMappingURL=index.js.map