'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resource = require('../resource');

var _resource2 = _interopRequireDefault(_resource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Waves = function (_Resource) {
    (0, _inherits3.default)(Waves, _Resource);

    function Waves() {
        (0, _classCallCheck3.default)(this, Waves);
        return (0, _possibleConstructorReturn3.default)(this, (Waves.__proto__ || (0, _getPrototypeOf2.default)(Waves)).apply(this, arguments));
    }

    (0, _createClass3.default)(Waves, [{
        key: 'getSubCollection',


        /**
         * @api {get} /v1/waves/:organization_subscription_wave_id/:sub_collection/:sub_sub_collection getSubCollection
         * @apiGroup Waves
         * @apiName getSubCollection
         * @apiDescription Get information regarding the specified sub-collection of the wave.
         * @apiParam {Number} organization_subscription_wave_id
         * @apiParam {String} sub_collection
         * @apiParam {String} sub_sub_collection
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.waves.getSubCollection({...})
         */
        value: function getSubCollection(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/waves/' + params.organization_subscription_wave_id + '/' + params.sub_collection + '/' + params.sub_sub_collection + query);
        }

        /**
         * @api {get} /v1/organization_subscription_waves/:organization_subscription_wave_id get
         * @apiGroup Waves
         * @apiName get
         * @apiDescription Get information regarding the specified wave.
         * @apiParam {Number} organization_subscription_wave_id
         * @apiParam {Object} [query]
         * @apiExample {js} Example:
         *             gigwalk.waves.get({...})
         */

    }, {
        key: 'get',
        value: function get(params) {
            var query = this.stringForQueryObject(params.query);

            return this.client.get('/v1/organization_subscription_waves/' + params.organization_subscription_wave_id + query);
        }

        /**
         * @api {post} /v1/waves/:organization_subscription_wave_id/csv create
         * @apiGroup Waves
         * @apiName create
         * @apiDescription Create wave using csv.
         * @apiParam {Number} organization_subscription_wave_id
         * @apiExample {js} Example:
         *             gigwalk.waves.create({...})
         */

    }, {
        key: 'create',
        value: function create(params) {
            return this.client.post('/v1/waves/' + params.organization_subscription_wave_id + '/csv');
        }
    }]);
    return Waves;
}(_resource2.default);

exports.default = Waves;
//# sourceMappingURL=index.js.map